package de.jave.eclipse.poormans.quickfixes;

import java.util.List;

import de.jave.eclipse.poormans.quickfixes.preferences.PoorMansQuickFixesPreferencesInitializer;
import de.jave.eclipse.poormans.quickfixes.regexp.RegExpQuickFix;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.plugin.AbstractUIPlugin;

public class PoorMansQuickFixesPlugin extends AbstractUIPlugin {

  private static final String ICON_IMAGE_KEY = "iconImage"; //$NON-NLS-1$

  private static PoorMansQuickFixesPlugin plugin;
  private List<RegExpQuickFix> quickFixes;

  public PoorMansQuickFixesPlugin() {
    plugin = this;
  }

  @Override
  protected ImageRegistry createImageRegistry() {
    final ImageRegistry registry = super.createImageRegistry();
    ImageDescriptor imageDescriptor = ImageDescriptor.createFromURL(PoorMansQuickFixesPlugin
        .getDefault().getBundle().getResource("icons/poor_man_quick_fix_icon.gif")); //$NON-NLS-1$
    registry.put(ICON_IMAGE_KEY, imageDescriptor);
    return registry;
  }

  public static PoorMansQuickFixesPlugin getDefault() {
    return plugin;
  }

  public List<RegExpQuickFix> getRegExpQuickFixes() {
    if (quickFixes == null) {
      quickFixes = PoorMansQuickFixesPreferencesInitializer.load(getPreferenceStore());
    }
    return quickFixes;
  }

  public void setQuickFixes(List<RegExpQuickFix> quickFixes) {
    this.quickFixes = quickFixes;
    PoorMansQuickFixesPreferencesInitializer.store(quickFixes, getPreferenceStore());
  }

  public Image getIcon() {
    return getImageRegistry().get(ICON_IMAGE_KEY);
  }
}