package de.jave.eclipse.poormans.quickfixes.regexp;

public class Ambience {

  private final String before;
  private final String after;

  public Ambience(String before, String after) {
    this.before = before;
    this.after = after;
  }

  public String getBefore() {
    return before;
  }

  public String getAfter() {
    return after;
  }

  public static Ambience createAmbience(String source, int startIndex, int endIndex) {
    String before = getBeforeAmbience(source, startIndex);
    String after = getAfterAmbience(source, endIndex);
    return new Ambience(before, after);
  }

  private static String getAfterAmbience(String source, int endIndex) {
    int lineBreakCount = 0;
    int index = endIndex + 1;
    while (index < source.length() && lineBreakCount < 2) {
      ++index;
      if (source.charAt(index) == '\n') {
        ++lineBreakCount;
      }
    }
    return source.substring(endIndex, index - 1);
  }

  private static String getBeforeAmbience(String source, int startIndex) {
    int lineBreakCount = 0;
    int index = startIndex - 1;
    while (index > 0 && lineBreakCount < 2) {
      --index;
      if (source.charAt(index) == '\n') {
        ++lineBreakCount;
      }
    }
    String before = source.substring(index + 1, startIndex);
    return before;
  }
}