//Copyright (c) 2006 by disy Informationssysteme GmbH
package de.jave.eclipse.poormans.quickfixes.regexp;

import de.jave.eclipse.poormans.quickfixes.PoorMansQuickFixesPlugin;

import org.eclipse.jdt.internal.ui.text.spelling.WordCorrectionProposal;
import org.eclipse.jdt.ui.text.java.IJavaCompletionProposal;
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.contentassist.IContextInformation;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;

// NOT_PUBLISHED
public final class TextReplaceCompletionProposal implements IJavaCompletionProposal {
  private final String name;
  private final int length;
  private final int offset;
  private final String replacement;
  private final String proposalInfo;
  private final int relevance;

  public TextReplaceCompletionProposal(
      String name,
      Ambience ambience,
      int offset,
      int length,
      String replacement,
      int relevance) {
    this.name = name;
    this.length = length;
    this.offset = offset;
    this.replacement = replacement;
    this.relevance = relevance;

    String before = WordCorrectionProposal.getHtmlRepresentation(ambience.getBefore());
    before = before.replace("\n", "<br>");
    String after = WordCorrectionProposal.getHtmlRepresentation(ambience.getAfter());
    after = after.replace("\n", "<br>");

    final StringBuffer buffer = new StringBuffer(80);
    buffer.append("...<br>"); //$NON-NLS-1$
    buffer.append(before);
    buffer.append("<b>"); //$NON-NLS-1$
    buffer.append(WordCorrectionProposal.getHtmlRepresentation(replacement));
    buffer.append("</b>"); //$NON-NLS-1$
    buffer.append(after);
    buffer.append("<br>..."); //$NON-NLS-1$
    this.proposalInfo = buffer.toString();
  }

  public int getRelevance() {
    return relevance;
  }

  public void apply(IDocument document) {
    try {
      document.replace(offset, length, replacement);
    }
    catch (BadLocationException e) {
      //ignore - just like they do in Eclipse...;
    }
  }

  public Point getSelection(IDocument document) {
    return null;
  }

  public String getAdditionalProposalInfo() {
    return proposalInfo;
  }

  public String getDisplayString() {
    return name;
  }

  public Image getImage() {
    return PoorMansQuickFixesPlugin.getDefault().getIcon();
  }

  public IContextInformation getContextInformation() {
    return null;
  }
}